#include "tb.h"

#include <stdlib.h>
#include <memory.h>
#include <string.h>

#include "cpptypes.h"
#include "debug.h"

int tb_sort_cel_compare(void * ffirst,void* ssecond,enum tb_type columntype)
{
  switch(columntype)
  {
  case tb_type_char:
    return strcmp((char*)ffirst,(char*)ssecond);
  case tb_type_double:
    if(*(double*)ffirst==*(double*)ssecond)
      return 0;
    return *(double*)ffirst<*(double*)ssecond?-1:1;
  case tb_type_int:
    if(*(int*)ffirst==*(int*)ssecond)
      return 0;
    return *(int*)ffirst<*(int*)ssecond?-1:1;
  }
}

int tb_sort_compare(struct tb_table* _t,int first,int second,int column)
{
  struct tb_column *col=&_t->columns[column];
  return tb_sort_cel_compare(_t->lines[first]+col->offset,
    _t->lines[second]+col->offset,col->type);
}

void tb_sort(struct tb_table *_t, int *_j, int _n, int *_o)
{
  int k;
  for (k = _t->lines_count/2; k > 0; k /= 2)
  {
    int i;
    for (i = k; i < _t->lines_count; i++)
    {
      int j;
      for (j = i; j >= k; j -= k)
      {
        int m,F;
        tb_line line;

        F=0;
        for (m = 0; m<_n&&F==0; m++)
          F|=tb_sort_compare(_t,j-k,j,_j[m]);
        if (F*(_o[m-1] | 1) < 0)
          break;

        line=_t->lines[j];
        _t->lines[j] = _t->lines[j-k];
        _t->lines[j-k] = line;
      }
    }
  }
}

int tb_bsearch(struct tb_table *_t, int *_j, int _n, void *_d[])
{
   int F;
   int i,m;
   int L,R;

   L = 0;
   R = _t->lines_count - 1;
   while (L <= R)
   {
      i = (L+R)/2;
      for (F = 0, m = 0; (m < _n) && (F == 0); m++)
        F |= tb_sort_cel_compare(_t->lines[i]+_t->columns[_j[m]].offset,_d[m],_t->columns[_j[m]].type);
      if (F == 0)
        break;
      if (F < 0)
        L=i+1;
      else
        R=i-1;
   }
   return (F == 0) ? i : -1;
}
